﻿using UnityEngine;
using System.Collections;

public class AudioTrigger : MonoBehaviour {

	public int sourceID;
	private string sourceReference;		//playerpref for the specific trigger

	private AudioSource source;
	public bool play;

	private GameObject[] Audio;

	// Use this for initialization
	void Start () {
		source = GetComponent<AudioSource>();
		sourceReference = Application.loadedLevelName+"/"+sourceID;
		play = false;

		Audio = GameObject.FindGameObjectsWithTag("Audio");

		if (PlayerPrefs.GetInt(sourceReference) != 1) {
			PlayerPrefs.SetInt(sourceReference, 0);
		}
	}

	//if player enters trigger, play the sound clip
	void OnTriggerEnter(Collider other) {
		if (other.tag == "Player" && PlayerPrefs.GetInt(sourceReference) != 1) {
			//Debug.Log("start playing");
			source.Play();
			play = true;
			StopAudio();
			/*foreach (GameObject a in Audio) {
				if (a != gameObject) {
					if (a.GetComponent<AudioTrigger>() != null) {
						a.GetComponent<AudioTrigger>().play = false;
					}
					else if (a.GetComponent<ButtonAudioTrigger>() != null) {
						a.GetComponent<ButtonAudioTrigger>().play = false;
					}
					else if (a.GetComponent<LimitTrigger>() != null) {
						a.GetComponent<LimitTrigger>().play = false;
					}
					else if (a.GetComponent<NumericalAudioTrigger>() != null) {
						a.GetComponent<NumericalAudioTrigger>().play = false;
					}
					a.audio.Stop();
				}
			}*/
		}
	}

	void Update() {
		if (play) {
			if (source.isPlaying == false) {	//check this after the clip has played
				//Debug.Log("stop playing");
				PlayerPrefs.SetInt(sourceReference, 1);
			}
		}
		//Debug.Log(PlayerPrefs.GetInt(sourceReference));
		if (Input.GetKeyDown(KeyCode.Backspace)) {
			PlayerPrefs.DeleteAll();
			Debug.Log("reset");
		}
	}

	void StopAudio() {
		//Debug.Log("stopping");
		foreach (GameObject a in Audio) {
			if (a != gameObject) {
				/*if (a.GetComponent<AudioTrigger>() != null) {
					a.GetComponent<AudioTrigger>().play = false;
				}
				else if (a.GetComponent<ButtonAudioTrigger>() != null) {
					a.GetComponent<ButtonAudioTrigger>().play = false;
				}
				else if (a.GetComponent<LimitTrigger>() != null) {
					a.GetComponent<LimitTrigger>().play = false;
				}
				else if (a.GetComponent<NumericalAudioTrigger>() != null) {
					a.GetComponent<NumericalAudioTrigger>().play = false;
				}*/

				if (a.audio.isPlaying) {
					a.audio.Stop();
				}
			}
		}
	}
}
