﻿using UnityEngine;
using System.Collections;

public class ButtonAudioTrigger : MonoBehaviour {

	public int sourceID;
	private string sourceReference;		//playerpref for the specific trigger
	
	private AudioSource source;
	private bool canPlay;				//detect wheter the player is in range of the trigger
	public bool play = false;

	private GameObject[] Audio;
	// Use this for initialization
	void Start () {
		source = GetComponent<AudioSource>();
		sourceReference = Application.loadedLevelName+"/"+sourceID;
		canPlay = false;

		Audio = GameObject.FindGameObjectsWithTag("Audio");

		if (PlayerPrefs.GetInt(sourceReference) != 1) {
			PlayerPrefs.SetInt(sourceReference, 0);
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (canPlay) {
			if (Input.GetKeyDown(KeyCode.F) && PlayerPrefs.GetInt(sourceReference) != 1) {
				source.Play();
				play = true;
				StopAudio();
				PlayerPrefs.SetInt(sourceReference, 1);
			}
		}
	}

	void OnTriggerEnter(Collider other) {
		if (other.tag == "Player") {
			canPlay = true;
		}
	}

	void OnTriggerExit(Collider other) {
		if (other.tag == "Player") {
			canPlay = false;
		}
	}

	void StopAudio() {
		foreach (GameObject a in Audio) {
			if (a != gameObject) {
				if (a.audio.isPlaying) {
					a.audio.Stop();
				}

				/*if (a.GetComponent<AudioTrigger>() != null) {
					a.GetComponent<AudioTrigger>().play = false;
				}
				else if (a.GetComponent<ButtonAudioTrigger>() != null) {
					a.GetComponent<ButtonAudioTrigger>().play = false;
				}
				else if (a.GetComponent<LimitTrigger>() != null) {
					a.GetComponent<LimitTrigger>().play = false;
				}
				else if (a.GetComponent<NumericalAudioTrigger>() != null) {
					a.GetComponent<NumericalAudioTrigger>().play = false;
				}
				a.audio.Stop();*/
			}
		}
	}
}
