﻿using UnityEngine;
using System.Collections;

public class BossObjectiveHealth : MonoBehaviour {

	public int health;
	public int startingHealth;	//the amount of health an enemy has before he starts taking damage;

	public Color[] states;

	/*
		1 = Fire
		2 = Electricity
	*/
	public int weakness;	//what this enemy is weak to
	public bool burning;
	public bool electric;	//are we shocking?
	public bool dead;
	private Renderer mr;
	private BasicEnemyMovement bem;
	
	float lastDamage = -10f;
	float deltaTime = 0f;
	float delay = 1f;	//interval in between time damage is dealt
	float fireTime;
	int fireDamage;

	//woogie woogie woogie
	float lastElectricDamage = -10f;
	float electricTime;
	int electricDamage;

	// Use this for initialization
	void Start () {
		dead = false;

		mr = GetComponent<Renderer>();
		states[1] = mr.material.color;
		
		startingHealth = health;
		fireTime = (float)(startingHealth/10f);
		fireDamage = startingHealth/30;

		electricTime = (float)(startingHealth/50f);
		electricDamage = startingHealth/40;

		//Debug.Log("Burn stats: "+fireTime+"||"+fireDamage);
		//Debug.Log("Shock stats: "+electricTime+"||"+electricDamage);
	}
	
	// Update is called once per frame
	void Update () {
		if (burning) {
			OnFire();
		}

		if (electric) {
			Electrocuted();
		}
		
		//Debug.Log("Enemy is burning: "+burning);
		
		if (health <= 0) {
			dead = true;
		}
	}

	public void Hurt(int damage) {
		Debug.Log("hurt "+ damage);
		health -= damage;
		StartCoroutine(Hurting());
	}
	
	IEnumerator Hurting() {
		mr.material.color = states[0];
		yield return new WaitForSeconds(0.5f);
		mr.material.color = states[1];
	}
	
	public void OnFire() {
		deltaTime += Time.deltaTime;	//start incrementing the timer
		//Debug.Log("Burning time elapsed: "+deltaTime);
		if (deltaTime <= fireTime) {
			//This next section deals damage during the time the enemy is on fire, but only during every second.
			if (deltaTime > delay+lastDamage) {
				Hurt(fireDamage);		//deal the damage
				Debug.Log(gameObject.name+" is burning");
				lastDamage = deltaTime;	//set the variable to the time the damage was dealt so the loop continues
			}
		}
		else {
			deltaTime = 0;		//reset the timer
			burning = false;	//we are no longer burning
		}
	}

	//for when things get SHOCKING
	public void Electrocuted() {
		deltaTime += Time.deltaTime;
		
		if (deltaTime <= electricTime) {
			if (deltaTime > delay+lastElectricDamage) {
				Hurt(electricDamage);
				Debug.Log(gameObject.name+" is SHOCKED at this predicament");
				lastElectricDamage = deltaTime;	//set the variable to the time the damage was dealt so the loop continues
			}
		}
		else {	//otherwise, reset everything
			deltaTime = 0;
			electric = false;
		}
	}
	
	IEnumerator Delay(float time) {
		yield return new WaitForSeconds(time);
		//attackCooldown = false;
	}
}
