﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class BossObjectiveManager : MonoBehaviour {

	public List<GameObject> objectives;
	public float downTime = 5f;		//how long the objective will be down before it comes back up
	float deadDeltaTime = 0;
	//bool allDead = true;
	public bool opening;			//letting other scripts know that the boss is weak

	// Use this for initialization
	void Start () {
		//allDead = false;
	}
	
	// Update is called once per frame
	void Update () {
		bool allDead = true;
		opening = true;

		foreach (GameObject o in objectives) {	//get all objectives
			//With this bit of logic, we're checking every item in the list to see if it's dead. With this statement,
			//if one item is "alive" then allDead will continue to return false.
			if (o.GetComponent<BossObjectiveHealth>().dead == false) {	//check if they've been disabled
				allDead = false;
				opening = false;
			}
		}

		if (allDead) {
			deadDeltaTime += Time.deltaTime;
			if (deadDeltaTime >= downTime) {		//check if we've past the correct amount of time
				foreach (GameObject o in objectives) {			//turn all of the objectives back on
					o.GetComponent<BossObjectiveHealth>().dead = false;		//reset dead boolean
					//restore health to full to repeat the cycle
					o.GetComponent<BossObjectiveHealth>().health = o.GetComponent<BossObjectiveHealth>().startingHealth;
				}
				deadDeltaTime = 0;		//reset our change in time
			}
		}
		//Debug.Log("Is everybody dead? "+allDead);
		//Debug.Log("hes weak: "+opening);
	}
}
