﻿using UnityEngine;
using System.Collections;

public class EnemyAttack : MonoBehaviour {

	public GameObject target;	//whatever the enemy is trying to hurt and kill
	public int damage = 10;
	public float attackGap = 3f;
	private float attackTimer;

	private bool inRange;
	// Use this for initialization
	void Start () {
		target = GameObject.FindGameObjectWithTag("Player");
	}
	
	// Update is called once per frame
	void Update () {
		//Debug.Log("Enemy can attack: "+inRange);
		if (inRange) {
			attackTimer += Time.deltaTime;
			if (attackTimer >= attackGap) {
				target.GetComponent<PlayerHealth>().Hurt(damage);
				attackTimer = 0f;
			}
		}
	}

	//determine if player can be attack
	void OnTriggerEnter(Collider other) {
		if (other.gameObject == target) {
			inRange = true;
		}
	}

	void OnTriggerExit(Collider other) {
		if (other.gameObject == target) {
			inRange = false;
		}
	}
}
