﻿using UnityEngine;
using System.Collections;

public class EnemyRangedAttack : MonoBehaviour {

	public GameObject target;	//whatever the enemy is trying to hurt and kill
	public GameObject projectile;	//what the enemy is shooting
	public float range = 5;
	public int damage = 10;
	public float attackGap = 3f;
	private float attackTimer;
	public float speed = 3;

	public bool isFiring;
	private bool inRange;
	// Use this for initialization
	void Start () {
		target = GameObject.FindGameObjectWithTag("Player");
		GetComponent<SphereCollider>().radius = range;
		inRange = false;
		isFiring = false;
	}
	
	// Update is called once per frame
	void Update () {
		//Debug.Log("firing: "+isFiring);

		if (inRange) {
			attackTimer += Time.deltaTime;
			Vector3 check = target.transform.position-transform.position;
			check.Normalize();
			if (attackTimer >= attackGap) {
				//attackTimer = 0f;
				GameObject projInst = Instantiate(projectile, transform.position+(Vector3.up), Quaternion.Euler(check)) as GameObject;
				projInst.GetComponent<EnemyProjectile>().destroyOnHit = true;
				projInst.GetComponent<EnemyProjectile>().damage = damage;
				Vector3 projSpeed = check*speed;
				projInst.rigidbody.velocity = new Vector3(projSpeed.x, 0, projSpeed.z);
				//target.GetComponent<PlayerHealth>().Hurt(damage);
				attackTimer = 0f;
			}

			if (attackTimer >= attackGap-0.5f && attackTimer <= attackGap ||
			    attackTimer <= 0.5f) {
				isFiring = true;
			}
			else {
				isFiring = false;
			}
		}
		else {
			isFiring = false;
		}
	}

	//using these instead of OnTriggerStay because it's a resource drain
	void OnTriggerEnter(Collider other) {
		if (other.gameObject == target) {
			inRange = true;
		}
	}
	
	void OnTriggerExit(Collider other) {
		if (other.gameObject == target) {
			inRange = false;
		}
	}
}
