﻿using UnityEngine;
using System.Collections;

public class RangedEnemyMovement : MonoBehaviour {

	public float backOff = 5f;
	public bool stunned = false;

	private NavMeshAgent moveAgent;
	private GameObject player;
	private EnemyHealth eh;
	private EnemyRangedAttack era;
	// Use this for initialization
	void Start () {
		moveAgent = GetComponent<NavMeshAgent>();
		player = GameObject.FindGameObjectWithTag("Player");
		eh = GetComponent<EnemyHealth>();
		era = GetComponent<EnemyRangedAttack>();

		moveAgent.updateRotation = false;
	}
	
	// Update is called once per frame
	void Update () {
		if (!eh.dead && !era.isFiring && !stunned) {
			Vector3 distance = transform.position-player.transform.position;
			if (distance.magnitude <= backOff) {
				moveAgent.SetDestination(transform.position+distance);
			}
			else {
				moveAgent.SetDestination(player.transform.position+distance);
			}
		}
		///both to make sure it completely stops moving
		else {
			rigidbody.velocity = Vector3.zero;
			rigidbody.angularVelocity = Vector3.zero;
		}
	}
}
