﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SpawnEnemyWaves : MonoBehaviour {

	public Rigidbody[] toSpawn;		//list of enemies the object can spawn
	public List<Rigidbody> wave;		//list of enemies in the current wave
	//private Rigidbody spawn;
	public Transform[] spawnPoints;
	public float spawnTime;		//the time we want to wait in between new enemies being released
	public float spawnTimer;	//where we keep track of time

	//private EnemyHealth eh;
	private bool invincible;
	// Use this for initialization
	void Start () {
		spawnTimer = 0;

		if (GetComponent<EnemyHealth>() != null) {
			//eh = GetComponent<EnemyHealth>();
			invincible = false;
		}
		else {
			invincible = true;
		}
	}
	
	// Update is called once per frame
	void Update () {
		spawnTimer += Time.deltaTime;
		if (spawnTimer >= spawnTime || wave.Count == 0) {	//if the time has elapsed or all enemies have been killed
			//Debug.Log("ding");
			foreach (Transform spawn in spawnPoints) {
				Debug.Log("spawning");
				Rigidbody s = Instantiate(toSpawn[(int)(Random.Range(0, toSpawn.Length-1))], spawn.position, spawn.rotation) as Rigidbody;
				wave.Add(s);	//add the object to the wave
				s.GetComponent<EnemyHealth>().weakness = (int)(Random.Range(1, 3));
			}
			spawnTimer = 0;
		}
	}
}