﻿using UnityEngine;
using System.Collections;

public class ExplosiveProjectile : MonoBehaviour {

	public int damage;
	public int damageType;
	public int radius;
	// Use this for initialization
	void Start () {
		Destroy(gameObject, 3);
	}

	void OnTriggerEnter(Collider other) {
		//notice we don't check for a tag here, only after we've done the overlap sphere. this is so we can still do damage
		//to enemies even if the projectile doesn't hit them.
		if (other.isTrigger == false) {
			Collider[] hits = Physics.OverlapSphere(transform.position, radius);
			foreach (Collider hit in hits) {
				if (hit.tag == "Enemy" && hit.isTrigger == false) {
					//Debug.Log(hit+"and"+hit.collider.isTrigger);
					if (hit.GetComponent<EnemyHealth>() != null) {
						EnemyHealth eh = hit.GetComponent<EnemyHealth>();
						eh.health -= damage;
						ElementalDamage(damageType, eh);
					}

					if (hit.collider.GetComponent<PropHealth>() != null) {
						if (hit.collider.GetComponent<PropHealth>().enabled == true) {
							hit.collider.GetComponent<PropHealth>().Hurt(damage);
						}
					}

					if (hit.GetComponent<BossObjectiveHealth>() != null) {
						BossObjectiveHealth boh = hit.GetComponent<BossObjectiveHealth>();
						boh.health -= damage;
						BossObjectiveElementalDamage(damageType, boh);
					}

					if (hit.GetComponent<BossHealth>() != null) {
						BossHealth bh = hit.GetComponent<BossHealth>();
						bh.health -= damage;
						BossElementalDamage(damageType, bh);
					}
				}
			}
			Destroy(gameObject);
		}
		/*else {
			Destroy(gameObject);
		}*/
	}

	void ElementalDamage(int damageType, EnemyHealth eh) {
		if (damageType == eh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				eh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				eh.electric = true;
			}
			else if (damageType == 3) {
				eh.flung = true;
			}
		}
	}
	
	void BossObjectiveElementalDamage(int damageType, BossObjectiveHealth boh) {
		if (damageType == boh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				boh.burning = true;
				//Debug.Log("On fire");
			}
		}
	}
	
	void BossElementalDamage(int damageType, BossHealth bh) {
		if (damageType == bh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				bh.burning = true;
				//Debug.Log("On fire");
			}
		}
	}
}
