﻿using UnityEngine;
using System.Collections;

public class Fire : MonoBehaviour {

	bool onPlayerEnter;
	float deltaTime = 0f;
	float delay = 1f;
	float lastDamage = -10f;
	PlayerHealth ph;
	// Use this for initialization
	void Start () {
		renderer.material.color = Color.red;
	}
	
	// Update is called once per frame
	void Update () {
		if (onPlayerEnter) {
			deltaTime += Time.deltaTime;	//start incrementing the timer
			int fireDamage = ph.startingHealth/30;
			//Debug.Log("Burning time elapsed: "+deltaTime);
			//This next section deals damage during the time the enemy is on fire, but only during every second.
			if (deltaTime > delay+lastDamage) {
				ph.Hurt(fireDamage);	//deal the damage
				//Debug.Log("You is burning");
				lastDamage = deltaTime;	//set the variable to the time the damage was dealt so the loop continues
			}
		}
		else {
			deltaTime = 0;		//reset the timer
		}
	}

	void OnTriggerEnter(Collider other) {
		if (other.tag == "Player") {
			onPlayerEnter = true;
			ph = other.GetComponent<PlayerHealth>();
		}
	}

	void OnTriggerExit(Collider other) {
		if (other.tag == "Player") {
			onPlayerEnter = false;
		}
	}
}
