﻿using UnityEngine;
using System.Collections;

public class PlayerHealth : MonoBehaviour {

	public int health = 100;
	public int startingHealth;
	public bool dead;
	public bool invincible;
	private PlayerControl pc;
	private SpriteRenderer sr;
	//private Material defMat;

	// Use this for initialization
	void Start () {
		pc = GetComponent<PlayerControl>();
		sr = GetComponent<SpriteRenderer>();
		//defMat = sr.material;

		startingHealth = health;
		invincible = false;
		dead = false;
	}
	
	// Update is called once per frame
	void Update () {
		if (health <= 0) {
			dead = true;
			pc.enabled = false;
		}
	}

	void OnCollisionEnter(Collision col) {
		if (col.collider.tag == "Pickup") {		//if we have hit a health pickup
			HealthPickup hp = col.gameObject.GetComponent<HealthPickup>();
			//restore hp
			if (health+hp.restore > startingHealth) {
				health = startingHealth;
			}
			else {
				health += hp.restore;
			}
			Destroy(col.gameObject);	//destroy it
		}
	}

	public void Hurt(int damage) {
		if (!invincible) {
			//Debug.Log("You are hurt!");
			health -= damage;
			StartCoroutine(Hurting());
		}
		else {
			Debug.Log("Tis but a scratch");
		}
	}

	IEnumerator Hurting() {
		//sr.material = null;
		sr.material.color = Color.red;
		//sr.material.shader = Shader.Find("FlashRed");
		yield return new WaitForSeconds(0.5f);
		//sr.material.shader = Shader.Find("Sprites/Diffuse");
		//sr.material = defMat;
		sr.material.color = Color.white;
	}
}
