﻿using UnityEngine;
using System.Collections;

public class Projectile : MonoBehaviour {

	public int damage;
	public int damageType;
	public bool destroyOnHit; //should the object be destroyed on first contact or should it keep going

	// Use this for initialization
	void Start () {
		Destroy(gameObject, 5);
	}

	void OnTriggerEnter(Collider other) {
		if (other.isTrigger == false) {
			if (other.tag == "Enemy") {
				//check which component the enemy has
				if (other.GetComponent<EnemyHealth>() != null) {
					other.GetComponent<EnemyHealth>().Hurt(damage);					//deal damage
					ElementalDamage(damageType, other.GetComponent<EnemyHealth>());	//deal elemental damage, if any
				}
				if (other.collider.GetComponent<PropHealth>() != null) {
					if (other.collider.GetComponent<PropHealth>().enabled == true) {
						other.collider.GetComponent<PropHealth>().Hurt(damage);
					}
				}
				if (other.GetComponent<BossObjectiveHealth>() != null) {
					other.GetComponent<BossObjectiveHealth>().Hurt(damage);
					BossObjectiveElementalDamage(damageType, other.GetComponent<BossObjectiveHealth>());
				}
				if (other.GetComponent<BossHealth>() != null && other.GetComponent<BossObjectiveManager>().opening) {
					other.GetComponent<BossHealth>().Hurt(damage);
					BossElementalDamage(damageType, other.GetComponent<BossHealth>());
				}

				if (destroyOnHit) {
					Destroy(gameObject);
				}
			}
			else {
				Destroy(gameObject);
			}
		}
	}

	void ElementalDamage(int damageType, EnemyHealth eh) {
		if (damageType == eh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				eh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				eh.electric = true;
			}
		}
	}
	
	void BossObjectiveElementalDamage(int damageType, BossObjectiveHealth boh) {
		if (damageType == boh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				boh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				boh.electric = true;
			}
		}
	}

	void BossElementalDamage(int damageType, BossHealth bh) {
		if (damageType == bh.weakness) {	//first check if the enemy is weak to the attack's damage
			Debug.Log("He's weak");
			if (damageType == 1) {
				bh.burning = true;
				//Debug.Log("On fire");
			}
			else if (damageType == 2) {
				bh.electric = true;
			}
		}
	}
}
