﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class RadialMenu : MonoBehaviour {
	public bool menuActive;
	public float radius = 75;
	public float buttonScaleX = 0.4f;
	public float buttonScaleY = 0.3f;
	public GameObject menu;

	private Button[] buttons;
	private Vector2 screenCenter;
	private Vector2 mouseAngle;
	float angle;
	int index;

	// Use this for initialization
	void Start () {
		buttons = menu.GetComponentsInChildren<Button>();
		int numButtons = buttons.Length;
		angle = 360/numButtons;
		//Debug.Log(angle);
		screenCenter = new Vector2(Screen.width/2, Screen.height/2);

		for (int i = 0; i < numButtons; i++) {
			float theta = (2 * Mathf.PI/numButtons) * i;
			int x = (int)(screenCenter.x+radius*Mathf.Cos(theta));
			int y = (int)(screenCenter.y+radius*Mathf.Sin(theta));
			buttons[i].GetComponent<RectTransform>().position = new Vector3(x, y, 0);
			//buttons[i].GetComponent<SetUIProportions>().xScale = buttonScaleX;
			//buttons[i].GetComponent<SetUIProportions>().yScale = buttonScaleY;
		}
	}
	
	// Update is called once per frame
	void Update () {
		if (Input.GetMouseButton(2)) {
			menu.SetActive(true);
			menuActive = true;
			mouseAngle = new Vector2(Input.mousePosition.x-screenCenter.x, Input.mousePosition.y-screenCenter.y);
			float a = Mathf.Atan2(mouseAngle.y, mouseAngle.x) * Mathf.Rad2Deg;
			a += (angle/2.0f);
			if (a < 0)
				a = a + 360;

			index = (int)(a/angle);

			if (Input.GetKeyDown(KeyCode.Alpha1)) {
				Debug.Log("You changed attack 1 to: "+index);
			}
			if (Input.GetKeyDown(KeyCode.Alpha2)) {
				Debug.Log("You changed attack 2 to: "+index);
			}
		}
		else {
			menu.SetActive(false);
			mouseAngle = Vector2.zero;
		}

		if (Input.GetMouseButtonUp(2)) {
			//if (menu.activeSelf == true) {
				Debug.Log("You have selected: "+index);
			//}
		}
	}
}
