﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class SetHealthUI : MonoBehaviour {

	private RectTransform rt;
	private Slider slider;
	private PlayerHealth ph;

	public GameObject color;
	public float xPos;
	public float yPos;
	public float xScale;
	public float yScale;

	// Use this for initialization
	void Start () {
		rt = GetComponent<RectTransform>();
		ph = GameObject.FindGameObjectWithTag("Player").GetComponent<PlayerHealth>();
		slider = GetComponent<Slider>();
		
		rt.sizeDelta = new Vector2(Screen.width * xScale, Screen.height * yScale);
		slider.maxValue = ph.health;
	}
	
	// Update is called once per frame
	void Update () {
		float xpos = Screen.width*xPos;
		float ypos = Screen.height*yPos;
		
		rt.position = new Vector3(xpos,ypos,0);
		slider.value = ph.health;

		color.GetComponent<Image>().color = Color.Lerp(Color.green, Color.red, 1-ph.health*0.01f);

		if (ph.dead == true) {
			color.GetComponent<Image>().color = new Color(1,1,1,0);
		}
	}
}
