﻿using UnityEngine;
using System.Collections;

//step into its space, awaken the foes
public class ActivateEnemies : MonoBehaviour {

	public GameObject[] enemies;
	private BasicEnemyMovement bem;
	private RangedEnemyMovement rem;
	private bool activated;		//safegard in case we enter the area again

	// Use this for initialization
	void Start () {
		activated = false;		//we haven't activated it yet
		foreach (GameObject g in enemies) {
			if (g.GetComponent<BasicEnemyMovement>() != null) {
				g.GetComponent<BasicEnemyMovement>().enabled = false;
			}

			if (g.GetComponent<RangedEnemyMovement>() != null) {
				g.GetComponent<RangedEnemyMovement>().enabled = false;
			}

			if (g.GetComponent<EnemyRangedAttack>() != null) {
				g.GetComponent<EnemyRangedAttack>().enabled = false;
			}

			if (g.GetComponent<NavMeshAgent>() != null) {
				g.GetComponent<NavMeshAgent>().enabled = false;
			}

			if (g.GetComponent<ActivateEnemies>() != null) {
				g.GetComponent<ActivateEnemies>().enabled = false;
			}
		}
	}

	void OnTriggerEnter(Collider other) {
		//check to see if it the player entering the space and we haven't already activate it
		if (other.tag == "Player" && activated == false) {
			foreach (GameObject g in enemies) {
				if (g.GetComponent<BasicEnemyMovement>() != null) {
					g.GetComponent<BasicEnemyMovement>().enabled = true;
				}

				if (g.GetComponent<RangedEnemyMovement>() != null) {
					g.GetComponent<RangedEnemyMovement>().enabled = true;
				}

				if (g.GetComponent<EnemyRangedAttack>() != null) {
					g.GetComponent<EnemyRangedAttack>().enabled = true;
				}

				if (g.GetComponent<NavMeshAgent>() != null) {
					g.GetComponent<NavMeshAgent>().enabled = true;
				}

				if (g.GetComponent<ActivateEnemies>() != null) {
					g.GetComponent<ActivateEnemies>().enabled = true;
				}
			}
			activated = true;		//signal that we have activated
		}
	}
}
