﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class LoadLevelbyName : MonoBehaviour {

	public string LevelName; //the string name of the level we want to load
	public int levelIndex;	//the numerical index of the level (only used if the name is not working)
	public Vector3 loadPos; //the position we want to be in when we load the level
	public string Tag;	//the tag of the object we want to use
	//public int doorID;	//unique numerical tag for each door object

	private GameObject player; //the player
	//private TextFade tf;
	private Text text;
	//private Vector3 screenPoint;
	private bool canTravel;

	// Use this for initialization
	void Start () {
		Tag = gameObject.tag;	//set the tag
		player = GameObject.FindGameObjectWithTag("Player"); //get the player
		canTravel = false;
		//text = GetComponentInChildren<Text>();
		//text.enabled = false;
		//tf = GetComponent<TextFade>();
	}

	void OnTriggerStay(Collider other) {
		if (other.tag == "Player") {
			//text.enabled = true;
			canTravel = true;
		}
	}

	void OnTriggerExit(Collider other) {
		if (other.tag == "Player") {
			//text.enabled = false;
			canTravel = false;
		}
	}
	
	// Update is called once per frame
	void Update () {
		//set the text position
		//screenPoint = Camera.main.WorldToScreenPoint(transform.position);
		//text.rectTransform.position = screenPoint;

		if (canTravel) {
			if (Input.GetKeyDown(KeyCode.F)) {
				Debug.DrawRay(player.transform.position, player.transform.TransformDirection(Vector3.right), Color.green);
				//send out a raycast in the direction the player is facing
				Application.LoadLevel(LevelName); //load the level
				//check the tag of the door
				player.transform.position = loadPos; //set player position
			}
		}
	}
	/*
	//fade out and in before loading level
	IEnumerator WaitForLoad(float waitTime, string LevelName) {
		float wait = waitTime;	//set the wait time
		yield return new WaitForSeconds(wait);	//wait for the required amount of time
		Application.LoadLevel(LevelName);	//after waiting, load the level
		//Debug.Log("Coroutine finished");
	}*/
}
